class EncoderFactorized(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  patcher3d : __torch__.projects.cosmos.tokenizer.v1.module.patching.Patcher3D
  conv_in : __torch__.torch.nn.modules.container.Sequential
  down : __torch__.torch.nn.modules.container.___torch_mangle_118.ModuleList
  mid : __torch__.torch.nn.modules.module.___torch_mangle_174.Module
  norm_out : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_176.CausalNormalize
  conv_out : __torch__.torch.nn.modules.container.___torch_mangle_181.Sequential
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.EncoderFactorized,
    input: Tensor) -> Tensor:
    conv_out = self.conv_out
    norm_out = self.norm_out
    mid = self.mid
    block_2 = mid.block_2
    mid0 = self.mid
    attn_1 = mid0.attn_1
    mid1 = self.mid
    block_1 = mid1.block_1
    down = self.down
    _2 = getattr(down, "2")
    block = _2.block
    _1 = getattr(block, "1")
    down0 = self.down
    _20 = getattr(down0, "2")
    block0 = _20.block
    _0 = getattr(block0, "0")
    down1 = self.down
    _10 = getattr(down1, "1")
    downsample = _10.downsample
    down2 = self.down
    _11 = getattr(down2, "1")
    block1 = _11.block
    _12 = getattr(block1, "1")
    down3 = self.down
    _13 = getattr(down3, "1")
    block2 = _13.block
    _00 = getattr(block2, "0")
    down4 = self.down
    _01 = getattr(down4, "0")
    downsample0 = _01.downsample
    down5 = self.down
    _02 = getattr(down5, "0")
    block3 = _02.block
    _14 = getattr(block3, "1")
    down6 = self.down
    _03 = getattr(down6, "0")
    block4 = _03.block
    _04 = getattr(block4, "0")
    conv_in = self.conv_in
    patcher3d = self.patcher3d
    _5 = (conv_in).forward((patcher3d).forward(input, ), )
    _6 = (_14).forward((_04).forward(_5, ), )
    _7 = (_00).forward((downsample0).forward(_6, ), )
    _3 = (_12).forward(_7, )
    _4 = (downsample).forward()
    _8 = (block_1).forward((_1).forward((_0).forward(_3, ), ), )
    _9 = (block_2).forward((attn_1).forward(_8, ), )
    _15 = (norm_out).forward(_9, )
    x = torch.mul(_15, torch.sigmoid(_15))
    return (conv_out).forward(x, )
class CausalConv3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv3d : __torch__.torch.nn.modules.conv.Conv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalConv3d,
    argument_1: Tensor) -> Tensor:
    conv3d = self.conv3d
    _8 = torch.slice(argument_1, 0, 0, 9223372036854775807)
    _9 = torch.slice(_8, 1, 0, 9223372036854775807)
    x_prev = torch.repeat(torch.slice(_9, 2, 0, 1), [1, 1, 0, 1, 1])
    input = torch.cat([x_prev, argument_1], 2)
    input0 = torch.pad(input, [1, 1, 1, 1, 0, 0], "constant", 0.)
    return (conv3d).forward(input0, )
class CausalResnetBlockFactorized3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm1 : __torch__.projects.cosmos.tokenizer.v1.module.utils.CausalNormalize
  conv1 : __torch__.torch.nn.modules.container.___torch_mangle_6.Sequential
  norm2 : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_8.CausalNormalize
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  conv2 : __torch__.torch.nn.modules.container.___torch_mangle_13.Sequential
  nin_shortcut : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_15.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalResnetBlockFactorized3d,
    argument_1: Tensor) -> Tensor:
    nin_shortcut = self.nin_shortcut
    conv2 = self.conv2
    dropout = self.dropout
    norm2 = self.norm2
    conv1 = self.conv1
    norm1 = self.norm1
    _10 = (norm1).forward(argument_1, )
    x = torch.mul(_10, torch.sigmoid(_10))
    _11 = (norm2).forward((conv1).forward(x, ), )
    input = torch.mul(_11, torch.sigmoid(_11))
    _12 = (conv2).forward((dropout).forward(input, ), )
    _13 = (nin_shortcut).forward(argument_1, )
    return torch.add(_13, _12)
class CausalHybridDownsample3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_34.CausalConv3d
  conv2 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_36.CausalConv3d
  conv3 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_38.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalHybridDownsample3d,
    argument_1: Tensor) -> Tensor:
    conv3 = self.conv3
    conv2 = self.conv2
    conv1 = self.conv1
    x = torch.pad(argument_1, [0, 1, 0, 1, 0, 0], "constant", 0.)
    _14 = (conv1).forward(x, )
    x2 = torch.avg_pool3d(x, [1, 2, 2], [1, 2, 2], [0, 0, 0])
    x0 = torch.add(_14, x2)
    _15 = torch.slice(x0, 0, 0, 9223372036854775807)
    _16 = torch.slice(_15, 1, 0, 9223372036854775807)
    x1 = torch.cat([torch.slice(_16, 2, 0, 1), x0], 2)
    _17 = (conv2).forward(x1, )
    x20 = torch.avg_pool3d(x1, [2, 1, 1], [2, 1, 1], [0, 0, 0])
    x3 = torch.add(_17, x20)
    return (conv3).forward(x3, )
class CausalAttnBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_137.CausalNormalize
  q : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_139.CausalConv3d
  k : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_141.CausalConv3d
  v : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_143.CausalConv3d
  proj_out : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_145.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalAttnBlock,
    argument_1: Tensor) -> Tensor:
    proj_out = self.proj_out
    v = self.v
    k = self.k
    q = self.q
    norm = self.norm
    _18 = (norm).forward(argument_1, )
    _19 = (q).forward(_18, )
    _20 = (k).forward(_18, )
    _21 = (v).forward(_18, )
    element = ops.prim.NumToTensor(torch.size(_19, 0))
    element0 = ops.prim.NumToTensor(torch.size(_19, 1))
    element1 = ops.prim.NumToTensor(torch.size(_19, 2))
    element2 = ops.prim.NumToTensor(torch.size(_19, 3))
    element3 = ops.prim.NumToTensor(torch.size(_19, 4))
    result = torch.mul(element, CONSTANTS.c0)
    _22 = int(torch.mul_(result, element1))
    _23 = int(torch.mul(element0, CONSTANTS.c0))
    _24 = int(torch.mul(element2, CONSTANTS.c0))
    _25 = int(torch.mul(element3, CONSTANTS.c0))
    x = torch.permute(_19, [0, 2, 1, 3, 4])
    q0 = torch.reshape(x, [_22, _23, _24, _25])
    element4 = ops.prim.NumToTensor(torch.size(_20, 0))
    element5 = ops.prim.NumToTensor(torch.size(_20, 1))
    element6 = ops.prim.NumToTensor(torch.size(_20, 2))
    element7 = ops.prim.NumToTensor(torch.size(_20, 3))
    element8 = ops.prim.NumToTensor(torch.size(_20, 4))
    result0 = torch.mul(element4, CONSTANTS.c0)
    _26 = int(torch.mul_(result0, element6))
    _27 = int(torch.mul(element5, CONSTANTS.c0))
    _28 = int(torch.mul(element7, CONSTANTS.c0))
    _29 = int(torch.mul(element8, CONSTANTS.c0))
    x3 = torch.permute(_20, [0, 2, 1, 3, 4])
    k0 = torch.reshape(x3, [_26, _27, _28, _29])
    dim = ops.prim.NumToTensor(torch.size(_21, 0))
    _30 = int(dim)
    element9 = ops.prim.NumToTensor(torch.size(_21, 0))
    element10 = ops.prim.NumToTensor(torch.size(_21, 1))
    element11 = ops.prim.NumToTensor(torch.size(_21, 2))
    element12 = ops.prim.NumToTensor(torch.size(_21, 3))
    element13 = ops.prim.NumToTensor(torch.size(_21, 4))
    result1 = torch.mul(element9, CONSTANTS.c0)
    _31 = int(torch.mul_(result1, element11))
    _32 = int(torch.mul(element10, CONSTANTS.c0))
    _33 = int(torch.mul(element12, CONSTANTS.c0))
    _34 = int(torch.mul(element13, CONSTANTS.c0))
    x4 = torch.permute(_21, [0, 2, 1, 3, 4])
    v0 = torch.reshape(x4, [_31, _32, _33, _34])
    b = ops.prim.NumToTensor(torch.size(q0, 0))
    _35 = int(b)
    _36 = int(b)
    _37 = int(b)
    _38 = int(b)
    c = ops.prim.NumToTensor(torch.size(q0, 1))
    _39 = int(c)
    _40 = int(c)
    _41 = int(c)
    _42 = int(c)
    h = ops.prim.NumToTensor(torch.size(q0, 2))
    _43 = int(h)
    w = ops.prim.NumToTensor(torch.size(q0, 3))
    _44 = int(w)
    q1 = torch.reshape(q0, [_38, _42, int(torch.mul(h, w))])
    q2 = torch.permute(q1, [0, 2, 1])
    k1 = torch.reshape(k0, [_37, _41, int(torch.mul(h, w))])
    w_ = torch.bmm(q2, k1)
    input = torch.mul(w_, CONSTANTS.c3)
    w_0 = torch.softmax(input, 2)
    v1 = torch.reshape(v0, [_36, _40, int(torch.mul(h, w))])
    w_1 = torch.permute(w_0, [0, 2, 1])
    h_ = torch.bmm(v1, w_1)
    x5 = torch.reshape(h_, [_35, _39, _43, _44])
    _45 = ops.prim.NumToTensor(torch.size(x5, 0))
    element14 = ops.prim.NumToTensor(torch.size(x5, 1))
    _46 = int(element14)
    element15 = ops.prim.NumToTensor(torch.size(x5, 2))
    _47 = int(element15)
    element16 = ops.prim.NumToTensor(torch.size(x5, 3))
    _48 = int(element16)
    other = torch.mul(dim, CONSTANTS.c0)
    element17 = torch.floor_divide(_45, other)
    _49 = [_30, int(element17), _46, _47, _48]
    x6 = torch.reshape(x5, _49)
    x7 = torch.permute(x6, [0, 2, 1, 3, 4])
    x8 = torch.add(argument_1, (proj_out).forward(x7, ))
    return x8
class CausalTemporalAttnBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_147.CausalNormalize
  q : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_149.CausalConv3d
  k : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_151.CausalConv3d
  v : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_153.CausalConv3d
  proj_out : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_155.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalTemporalAttnBlock,
    argument_1: Tensor) -> Tensor:
    proj_out = self.proj_out
    v = self.v
    k = self.k
    q = self.q
    norm = self.norm
    _50 = (norm).forward(argument_1, )
    _51 = (q).forward(_50, )
    _52 = (k).forward(_50, )
    _53 = (v).forward(_50, )
    element = ops.prim.NumToTensor(torch.size(_51, 0))
    _54 = int(element)
    dim = ops.prim.NumToTensor(torch.size(_51, 3))
    _55 = int(dim)
    element18 = ops.prim.NumToTensor(torch.size(_51, 0))
    element19 = ops.prim.NumToTensor(torch.size(_51, 1))
    element20 = ops.prim.NumToTensor(torch.size(_51, 2))
    element21 = ops.prim.NumToTensor(torch.size(_51, 3))
    element22 = ops.prim.NumToTensor(torch.size(_51, 4))
    result = torch.mul(element18, CONSTANTS.c0)
    result2 = torch.mul_(result, element21)
    _56 = int(torch.mul_(result2, element22))
    _57 = int(torch.mul(element19, CONSTANTS.c0))
    _58 = int(torch.mul(element20, CONSTANTS.c0))
    x = torch.permute(_51, [0, 3, 4, 1, 2])
    q3 = torch.reshape(x, [_56, _57, _58])
    element23 = ops.prim.NumToTensor(torch.size(_52, 0))
    element24 = ops.prim.NumToTensor(torch.size(_52, 1))
    element25 = ops.prim.NumToTensor(torch.size(_52, 2))
    element26 = ops.prim.NumToTensor(torch.size(_52, 3))
    element27 = ops.prim.NumToTensor(torch.size(_52, 4))
    result3 = torch.mul(element23, CONSTANTS.c0)
    result4 = torch.mul_(result3, element26)
    _59 = int(torch.mul_(result4, element27))
    _60 = int(torch.mul(element24, CONSTANTS.c0))
    _61 = int(torch.mul(element25, CONSTANTS.c0))
    x9 = torch.permute(_52, [0, 3, 4, 1, 2])
    k2 = torch.reshape(x9, [_59, _60, _61])
    element28 = ops.prim.NumToTensor(torch.size(_53, 0))
    element29 = ops.prim.NumToTensor(torch.size(_53, 1))
    element30 = ops.prim.NumToTensor(torch.size(_53, 2))
    element31 = ops.prim.NumToTensor(torch.size(_53, 3))
    element32 = ops.prim.NumToTensor(torch.size(_53, 4))
    result5 = torch.mul(element28, CONSTANTS.c0)
    result6 = torch.mul_(result5, element31)
    _62 = int(torch.mul_(result6, element32))
    _63 = int(torch.mul(element29, CONSTANTS.c0))
    _64 = int(torch.mul(element30, CONSTANTS.c0))
    x10 = torch.permute(_53, [0, 3, 4, 1, 2])
    v2 = torch.reshape(x10, [_62, _63, _64])
    bhw = ops.prim.NumToTensor(torch.size(q3, 0))
    _65 = int(bhw)
    c = ops.prim.NumToTensor(torch.size(q3, 1))
    _66 = int(c)
    t = ops.prim.NumToTensor(torch.size(q3, 2))
    _67 = int(t)
    q4 = torch.permute(q3, [0, 2, 1])
    k3 = torch.permute(k2, [0, 2, 1])
    v3 = torch.permute(v2, [0, 2, 1])
    w_ = torch.bmm(q4, torch.permute(k3, [0, 2, 1]))
    w_2 = torch.mul(w_, CONSTANTS.c3)
    _68 = torch.ones_like(w_2, dtype=None, layout=None, device=None, pin_memory=False)
    mask = torch.tril(_68)
    input = torch.masked_fill(w_2, torch.eq(mask, 0), -inf)
    w_3 = torch.softmax(input, 2)
    h_ = torch.bmm(w_3, v3)
    x11 = torch.reshape(torch.permute(h_, [0, 2, 1]), [_65, _66, _67])
    _69 = ops.prim.NumToTensor(torch.size(x11, 0))
    element33 = ops.prim.NumToTensor(torch.size(x11, 1))
    _70 = int(element33)
    element34 = ops.prim.NumToTensor(torch.size(x11, 2))
    _71 = int(element34)
    known_product = torch.mul(dim, CONSTANTS.c0)
    other = torch.mul_(known_product, element)
    element35 = torch.floor_divide(_69, other)
    _72 = [_54, _55, int(element35), _70, _71]
    x12 = torch.reshape(x11, _72)
    x13 = torch.permute(x12, [0, 3, 4, 1, 2])
    x14 = torch.add(argument_1, (proj_out).forward(x13, ))
    return x14
class DecoderFactorized(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  unpatcher3d : __torch__.projects.cosmos.tokenizer.v1.module.patching.UnPatcher3D
  conv_in : __torch__.torch.nn.modules.container.___torch_mangle_186.Sequential
  mid : __torch__.torch.nn.modules.module.___torch_mangle_244.Module
  up : __torch__.torch.nn.modules.container.___torch_mangle_418.ModuleList
  norm_out : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_420.CausalNormalize
  conv_out : __torch__.torch.nn.modules.container.___torch_mangle_425.Sequential
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.DecoderFactorized,
    argument_1: Tensor) -> Tensor:
    unpatcher3d = self.unpatcher3d
    conv_out = self.conv_out
    norm_out = self.norm_out
    up = self.up
    _0 = getattr(up, "0")
    block = _0.block
    _2 = getattr(block, "2")
    up0 = self.up
    _016 = getattr(up0, "0")
    block5 = _016.block
    _1 = getattr(block5, "1")
    up1 = self.up
    _017 = getattr(up1, "0")
    block6 = _017.block
    _018 = getattr(block6, "0")
    up2 = self.up
    _110 = getattr(up2, "1")
    upsample = _110.upsample
    up3 = self.up
    _111 = getattr(up3, "1")
    block7 = _111.block
    _22 = getattr(block7, "2")
    up4 = self.up
    _112 = getattr(up4, "1")
    block8 = _112.block
    _113 = getattr(block8, "1")
    up5 = self.up
    _114 = getattr(up5, "1")
    block9 = _114.block
    _019 = getattr(block9, "0")
    up6 = self.up
    _23 = getattr(up6, "2")
    upsample0 = _23.upsample
    up7 = self.up
    _24 = getattr(up7, "2")
    block10 = _24.block
    _25 = getattr(block10, "2")
    up8 = self.up
    _26 = getattr(up8, "2")
    block11 = _26.block
    _115 = getattr(block11, "1")
    up9 = self.up
    _27 = getattr(up9, "2")
    block12 = _27.block
    _020 = getattr(block12, "0")
    mid = self.mid
    block_2 = mid.block_2
    mid2 = self.mid
    attn_1 = mid2.attn_1
    mid3 = self.mid
    block_1 = mid3.block_1
    conv_in = self.conv_in
    _73 = (block_1).forward((conv_in).forward(argument_1, ), )
    _74 = (block_2).forward((attn_1).forward(_73, ), )
    _75 = (_115).forward((_020).forward(_74, ), )
    _76 = (_25).forward(_75, )
    _77 = (upsample0).forward()
    _78 = (_113).forward((_019).forward(_76, ), )
    _79 = (upsample).forward((_22).forward(_78, ), )
    _80 = (_1).forward((_018).forward(_79, ), )
    _81 = (norm_out).forward((_2).forward(_80, ), )
    x = torch.mul(_81, torch.sigmoid(_81))
    _82 = (unpatcher3d).forward((conv_out).forward(x, ), )
    return _82
class CausalHybridUpsample3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_354.CausalConv3d
  conv2 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_356.CausalConv3d
  conv3 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_358.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalHybridUpsample3d,
    argument_1: Tensor) -> Tensor:
    conv3 = self.conv3
    conv2 = self.conv2
    conv1 = self.conv1
    x = torch.repeat_interleave(argument_1, 2, 2)
    _83 = torch.slice(x, 2, 1, 9223372036854775807)
    _84 = torch.slice(_83, 3, 0, 9223372036854775807)
    x15 = torch.slice(_84, 4, 0, 9223372036854775807)
    x16 = torch.add((conv1).forward(x15, ), x15)
    x17 = torch.repeat_interleave(torch.repeat_interleave(x16, 2, 3), 2, 4)
    x18 = torch.add((conv2).forward(x17, ), x17)
    return (conv3).forward(x18, )
